<template>
  <div class="hotelBooking">
    <b-container>
      <div class="my-4">
        <img
          class="logo"
          src="@/assets/teknasyon-logo.png">
      </div>
      <b-card
        class="mb-4 p-3 card"
        no-body>
        <b-row class="mb-3 pb-1 border-bottom">
          <b-col
            v-for="(step, index) in steps"
            :key="index"
            sm="12" md="4">
            <b
              class="tabTitle"
              :class="{ 'tabTitle-active': activeStep === index }">
              {{ step.name }}
            </b>
          </b-col>
        </b-row>
        <date
          v-if="activeStep === 0"
          :ref="steps[0].name"
          :check-in="steps[0].data.checkIn"
          :check-out="steps[0].data.checkOut"
          @setCheckIn="setCheckIn"
          @setCheckOut="setCheckOut" />
        <room
          v-if="activeStep === 1"
          :ref="steps[1].name"
          :check-in="steps[0].data.checkIn"
          :check-out="steps[0].data.checkOut"
          :room-type="steps[1].data.roomType"
          :room-view="steps[1].data.roomView"
          @setRoomType="setRoomType"
          @setRoomView="setRoomView" />
        <payment
          v-if="activeStep === 2"
          :ref="steps[2].name"
          :check-in="steps[0].data.checkIn"
          :check-out="steps[0].data.checkOut"
          :room-type="steps[1].data.roomType"
          :room-view="steps[1].data.roomView"
          :card-holder-name="steps[2].data.cardHolderName"
          :card-number="steps[2].data.cardNumber"
          :exp-date-month="steps[2].data.expDateMonth"
          :exp-date-year="steps[2].data.expDateYear"
          :cvc="steps[2].data.cvc"
          @setCardHolderName="setCardHolderName"
          @setCVC="setCVC"
          @setExpDateMonth="setExpDateMonth"
          @setExpDateYear="setExpDateYear"
          @setCardNumber="setCardNumber" />
      </b-card>
      <div class="mb-4">
        <b-button
          class="mr-2"
          :disabled="activeStep === 0"
          @click="changeStep(activeStep - 1)">
            Back
        </b-button>
        <b-button
          v-if="activeStep !== 2"
          variant="success"
          @click="changeStep(activeStep + 1)">
            Next
        </b-button>
        <b-button
          v-if="activeStep === 2"
          variant="success"
          @click="submit">
            Submit
        </b-button>
      </div>
    </b-container>
  </div>
</template>

<script>
import Date from './components/Date'
import Room from './components/Room'
import Payment from './components/Payment'

export default {
  data () {
    return {
      activeStep: 0,
      steps: [
        {
          name: 'Date',
          data: {
            checkIn: '',
            checkOut: ''
          }
        },
        {
          name: 'Room',
          data: {
            roomType: '',
            roomView: ''
          }
        },
        {
          name: 'Payment',
          data: {
            cardHolderName: '',
            cardNumber: '',
            expDateMonth: '',
            expDateYear: '',
            cvc: ''
          }
        }
      ]
    }
  },

  components: {
    Date,
    Room,
    Payment
  },

  computed: {
    stepName () {
      return this.steps[this.activeStep].name
    }
  },

  methods: {
    fetchLocalStorage () {
      const data = localStorage.getItem('HotelBookingData')

      if (data !== null) {
        const parsedData = JSON.parse(data)
        this.steps = parsedData.steps
        this.activeStep = parsedData.activeStep
      }
    },
    setLocalStorage () {
      localStorage.setItem('HotelBookingData', JSON.stringify({ activeStep: this.activeStep, steps: this.steps }))
    },
    changeStep (step) {
      if (step > this.activeStep) {
        this.$refs[this.stepName].$validator.validateAll()

        setTimeout(() => {
          if (this.errors.items.length !== 0) {
            this.showErrorMessage()

            return
          }

          this.activeStep = step

          this.setLocalStorage()
        }, 100)

        return
      }

      this.activeStep = step
    },
    showErrorMessage () {
      this.$bvToast.toast('Please fill all of the fields correctly.', {
        title: 'Failed',
        variant: 'danger',
        solid: true
      })
    },
    showSuccessMessage () {
      this.$bvToast.toast('Please check the console :)', {
        title: 'Succeed',
        variant: 'success',
        solid: true
      })
    },
    submit () {
      this.$refs[this.stepName].$validator.validateAll()

      setTimeout(() => {
        if (this.errors.items.length !== 0) {
          this.showErrorMessage()

          return
        }

        this.showSuccessMessage()
        this.setLocalStorage()

        console.table({
          checkIn: this.steps[0].data.checkIn,
          checkOut: this.steps[0].data.checkOut,
          roomType: this.steps[1].data.roomType,
          roomView: this.steps[1].data.roomView,
          cardHolderName: this.steps[2].data.cardHolderName,
          cardNumber: this.steps[2].data.cardNumber,
          expDate: `${this.steps[2].data.expDateMonth}/${this.steps[2].data.expDateYear}`,
          cvc: this.steps[2].data.cvc
        })
      }, 100)
    },
    setCheckIn (value) {
      this.steps[0].data.checkIn = value
    },
    setCheckOut (value) {
      this.steps[0].data.checkOut = value
    },
    setRoomType (value) {
      this.steps[1].data.roomType = value
    },
    setRoomView (value) {
      this.steps[1].data.roomView = value
    },
    setCardHolderName (value) {
      this.steps[2].data.cardHolderName = value
    },
    setCVC (value) {
      this.steps[2].data.cvc = value
    },
    setExpDateMonth (value) {
      this.steps[2].data.expDateMonth = value
    },
    setExpDateYear (value) {
      this.steps[2].data.expDateYear = value
    },
    setCardNumber (value) {
      this.steps[2].data.cardNumber = value
    }
  },

  beforeMount () {
    this.fetchLocalStorage()
  }
}
</script>

<style scoped>
.card {
  min-height: 70vh;
}
.logo {
  width: 250px;
}
.tabTitle {
  display: block;
  text-align: center;
  text-transform: uppercase;
  font-size: 1.2em;
  margin-bottom: 10px;
  color: gray;
}
.tabTitle-active {
  color: #0098c6 !important;
}
</style>
